include \masm32\include\masm32rt.inc

; CONSOLE assemble and link

opsize MACRO arg
LOCAL LocArg
ifndef OpSizeDD
	.data?
	OpSizeDD	dd ?
	.code
	echo dd defined
endif
ifb <arg>
	echo IsBlank
	call @F
@@:	pop OpSizeDD   ; contains EIP of pop instruction
else
	flag SUBSTR <arg>, 2,1
	ifidn flag, <:>
		LocArg CATSTR <">, @SubStr(<arg>, 3)
		LocLen SIZESTR LocArg
		LocIns SUBSTR LocArg, 2, LocLen-2
		tmp$ CATSTR <TheSize=>, %LocLen, <, Ins=>, LocIns
;		% echo tmp$
;		echo IsBlank
		call @F
@@:		pop OpSizeDD   ; contains EIP of pop instruction
		LocIns
;		echo we got a flag
;		% echo flag
;		% echo LocArg
;		.err
	else
		LocArg equ <arg>
		tmp$ CATSTR <TheOldArg=>, LocArg
		% echo tmp$
	endif
	echo IsNotBlank <arg>
	call @F
@@:	push eax
	mov eax, [esp+4]
	sub eax, 11
	sub OpSizeDD, eax   ; contains EIP of pop instruction
	neg OpSizeDD
	pop eax
	add esp, 4
	pushad
	print chr$(13, 10, 32)
	print str$(OpSizeDD)
	print chr$(9, LocArg)
	; invoke MessageBox, 0, str$(OpSizeDD), chr$(LocArg), MB_OK
	popad
endif
ENDM

.code
AppName	db "Get the size of a piece of code in bytes:", 0
start:

print offset AppName, 13, 10

push eax
;opsize
;.While 1	; not a good idea
;.Endw
;opsize ".While 0 ... .Endw"
opsize
	.if 1
	.endif
opsize ".if 1 ... .endif"
opsize
	.if eax
		nop
	.endif
opsize ".if eax ... nop ... .endif"
opsize
	test eax, eax
	je @F
	nop
	@@:
opsize "test eax, eax .. nop ... je @F"
opsize
	.While 0
	.Endw
opsize ".While 0 ... .Endw"
opsize ":sub [esp], eax"
opsize ":sub dword ptr [esp], 127"
opsize ":sub dword ptr [esp], 128"
pop eax
opsize ":push eax"
opsize ":pop eax"
opsize ":pushad"
opsize ":popad"
opsize ":inc eax"
opsize ":add eax, 1"
opsize ":or eax, -1"
opsize ":mov eax, -1"
opsize ":and eax, 0"
opsize ":mov eax, 0"
opsize ":mov ax, 0"
opsize ":mov al, 0"
opsize ":add eax, 127"
opsize ":add ax, 127"
opsize ":add al, 0"
opsize ":add eax, 128"
opsize ":add ax, 128"
opsize ":add al, 128"
opsize ":mov edx, offset AppName"
opsize ":lea edx, AppName"
opsize ":lea edx, [AppName+4*eax]"
opsize ":lea edx, [AppName+4*eax+8]"
opsize ":lea edx, [AppName+4*eax+ecx+8]"
and eax, 3	; we get a dword from memory, so we
and ecx, 3	; better make sure the address is close...
opsize ":mov edx, dword ptr [AppName+4*eax+ecx+8]"

opsize
	jmp @F
@@:
opsize "jmp @F  "

opsize
	mov ecx, 99
@@:	dec ecx
	jne @B
opsize "loop: mov ecx, 99 - dec ecx - jne @B"

opsize
	m2m ecx, 99
@@:	dec ecx
	jne @B
opsize "loop: m2m ecx, 99 - dec ecx - jne @B"

opsize
	m2m ecx, 99
	.While ecx
		dec ecx
	.Endw
opsize ".While ecx - dec ecx - .Endw"

opsize
	m2m ecx, 99
	.While !SIGN?
		dec ecx
	.Endw
opsize ".While not sign"

opsize
	m2m ecx, 99
	.While 1
		dec ecx
		.break .if zero?
	.Endw
opsize ".While 1 - dec ecx - ,break .if zero?, ecx="
print str$(ecx)

opsize
	m2m ecx, 99
	.While 1
		dec ecx
		.break .if sign?
	.Endw
opsize ".While 1 - dec ecx - ,break .if sign?, ecx="
print str$(ecx)

opsize
	m2m ecx, 99
	.While !ZERO?
		dec ecx
	.Endw
opsize ".While not zero (fails miserably!)"

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until ecx==0
opsize ".Repeat/.Until ecx==0, ecx="
print str$(ecx)

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until Zero?
opsize ".Repeat/.Until zero?, ecx="
print str$(ecx)

opsize
	m2m ecx, 99
	.Repeat
		dec ecx
	.Until SIGN?
opsize ".Repeat/.Until sign?, ecx="
print str$(ecx)

print chr$(13, 10,10)

	; mbDebug 0, "Test", esp

; inkey "Hit any key to get outta here"
exit

end start
OPT_Linker	polink	; delete the red x if you want to use Pelle's linker
OPT_Tmp2Asm	1
OPT_Wait	1
OPT_SUSY	CONSOLE
